/*
 * ACTIVITY
 * 
 * Complete the code to make a phone dialing application.
 * It should display "Number: " followed by the currently entered digits.
 * Below this, display 4 rows of buttons for the phone keys:
 *   1 2 3
 *   4 5 6
 *   7 8 9
 *   * 0 #
 * 
 * Also, play the DTMF tone for the button hit by the user.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Dialer extends JFrame implements ActionListener
{
    private JLabel number= new JLabel("Number: ");

    private static final String [] KEYS       = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "*", "0", "#"};
    private static final String [] DTMF_AUDIO = {"Dtmf-1.wav",
                                                 "Dtmf-2.wav",
                                                 "Dtmf-3.wav",
                                                 "Dtmf-4.wav",
                                                 "Dtmf-5.wav",
                                                 "Dtmf-6.wav",
                                                 "Dtmf-7.wav",
                                                 "Dtmf-8.wav",
                                                 "Dtmf-9.wav",
                                                 "Dtmf-star.wav",
                                                 "Dtmf-0.wav",
                                                 "Dtmf-pound.wav"};
    private JButton buttons[];

    public void actionPerformed(ActionEvent event)
    {
        for (int i = 0; i < buttons.length; i++)
        {
            if (event.getSource() == buttons[i])
            {
                // Append the new digit on to the running text result
                ***TBD***

                // Play the audio for the given button
                ***TBD***
                
                return;
            }
        }
    }

    public Dialer()
    {
        buttons = new JButton[KEYS.length];
        for (int i = 0; i < KEYS.length; i++)
        {
            buttons[i] = new JButton(KEYS[i]);
            buttons[i].addActionListener(***TBD***);
        }

        getContentPane().add(number, BorderLayout.NORTH);

        JPanel dialPad = new JPanel();
        dialPad.setLayout(***TBD***);

        for (int i = 0; i < KEYS.length / 3; i++)
        {
            JPanel row = new JPanel();
            row.setLayout(***TBD***);
            row.add(buttons[***TBD***]);
            row.add(buttons[***TBD***]);
            row.add(buttons[***TBD***]);

            dialPad.add(row);
        }

        getContentPane().add(dialPad, BorderLayout.SOUTH);

        setTitle("Phone dialer");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(250, 250);
        setVisible(true);

    }

    public static void main(String [] args)
    {
        Dialer dialer = new Dialer();
    }
}
