/*
 * ACTIVITY
 * 
 * LEVEL 1: Create a JFrame application containing a JPanel that allows the 
 * use to draw with a big colored circle centered at the mouse.  
 * 
 * Left button changes the current drawing color.
 * Right button clears the screen.
 * 
 * LEVEL 2: Once mouse-based interaction is working, add code that allows
 * the radius of the spray paint to be increased and decreased using the
 * '+' and '-' keys.  HINT: don't forget to make your panel focusable!
 * 
 * LEVEL 3: Add additional drawing mode of your own invention, ideas:
 * 1) Make it possible to toggle the spray paint on or off
 * 2) Support different shaped nozzles (e.g. square instead of circle)
 * 3) Allow selection of different colors from a set using the nubmer keys
 * 4) ...
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class SprayPaint extends JFrame
{   
    private class SprayPanel extends JPanel implements TBD
    {
        // Current mouse location, starts out as an invalid off-screen location so 
        // nothing appears until the user moves the mouse inside the panel.
        private int x = Integer.MIN_VALUE;
        private int y = Integer.MIN_VALUE;
        
        // Current color to draw in, use partial transparency for extra fun
        private Color color = new Color(0.0f, 0.0f, 0.0f, 0.2f);

        // Used so the mouse handler can tell paintComponent to clear the screen
        private boolean clear = false;
        
        // Default constructor for the panel
        public SprayPanel()
        {
            // Hook up the listeners so we respond to mouse movement and clicking
            ***TBD***   
        }
        
        // Do some drawing on the panel
        public void paintComponent(Graphics g)        
        {
            // Check if they clicked and want to clear the display
            if (clear)
            {
                ***TBD***  
            }
            
            // Draw a circle of radius 30 in the current color centered at the mouse
            ***TBD***   
        }
        
        // Update the current mouse position and force an update of the drawing panel
        public void mouseMoved(MouseEvent event)
        {
            ***TBD***  
        }
        public void mouseDragged(MouseEvent event) {}
        
        public void mouseClicked(MouseEvent event) {}
        public void mouseEntered(MouseEvent event) {}
        public void mouseExited(MouseEvent event)  {}
        public void mousePressed(MouseEvent event) {}

        // Change the color to a new random color whenever the mouse is released.
        // Force an update of the drawing panel.
        public void mouseReleased(MouseEvent event)
        {
            ***TBD***  
        }
        
    }
    
    // Java JFrame that lets people draw using a big circle that randomly changes color
    // when the user clicks on it.
    public SprayPaint()
    {
        // Create the panel and add it to the JFrame        
        ***TBD***   
        
        setTitle("Spray paint");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(400, 400);
        setVisible(true);
    }

    public static void main(String [] args)
    {
        SprayPaint paint = new SprayPaint();
    }
    
}
